"use strict";
import { util } from './util.js'
class verify {
    //校验是不是整数整数
    static mustInt(value) {
        let isPass = true;

        if (util.isNull(value)) {
            isPass = false;
        } else {
            let reg = /^\+?[0-9]*$/;
            if (reg.test(value) == true) {
                isPass = true;
            } else {
                isPass = false;
            }
        }
        let returnObj = { isPass: '', message: '' }
        if (!isPass) {
            returnObj.isPass = 'false';
            returnObj.message = '必须填写为整数'
        } else {
            returnObj.isPass = 'true';
        }
        return returnObj;
    };

    /**
     * 校验是不是数值,小数点和整数
     * @param value 不能为空 校验值
     */
    static mustDouble(value) {
        let isPass = true;
        let reg = /^(-)?\d+(\.\d+)?$/;
        if (reg.exec(value) == null || value == "") {
            isPass= false;
        } else {
            isPass=  true;
        }
        let returnObj = { isPass: '', message: '' }
        if (!isPass) {
            returnObj.isPass = 'false';
            returnObj.message = '必须填写为数值，可为整数或者带小数位的数值'
        } else {
            returnObj.isPass = 'true';
        }
        return returnObj;
    }
    /**
     * 校验是不是金额
     * @param value 不能为空 校验值
     * @param eleObj 允许为空 组件对象，setValue时用到
     */
    static mustSum(value,eleObj) {
        let isPass = true;

        if (!/^-?\d+\.\d{2}$/.test(value) || value == "") {
            isPass= false;
        } else {
            isPass=  true;
        }
        let returnObj = { isPass: '', message: '' }
        if (!isPass) {
            if(!util.isNull(eleObj)&&this.mustInt(value).isPass=='true'){
                eleObj.setValue(value+'.00');
                returnObj.isPass = 'true';
            }else if(!util.isNull(eleObj)&&this.mustDouble(value).isPass=='true'){
                eleObj.setValue(value+'0');
            }else{
                returnObj.isPass = 'false';
                returnObj.message = '需精确到小数点后两位，示例：0.00'
            }
        } else {
            returnObj.isPass = 'true';
        }
        return returnObj;
    }

    //校验是不是手机号
    static mustPhoneNumber(value) {
        let isPass = true;
        let reg = /^(13[0-9]|14[01456879]|15[0-35-9]|16[2567]|17[0-8]|18[0-9]|19[0-35-9])\d{8}$/;
        if (reg.test(value) == true) {
            isPass=  true;
        } else {
            isPass=  false;
        }
        let returnObj = { isPass: '', message: '' }
        if (!isPass) {
            returnObj.isPass = 'false';
            returnObj.message = '请填写合法的手机号'
        } else {
            returnObj.isPass = 'true';
        }
        return returnObj;
    }

    /*
    * 身份证15位编码规则：dddddd yymmdd xx p
    * dddddd：6位地区编码
    * yymmdd: 出生年(两位年)月日，如：910215
    * xx: 顺序编码，系统产生，无法确定
    * p: 性别，奇数为男，偶数为女
    *
    * 身份证18位编码规则：dddddd yyyymmdd xxx y
    * dddddd：6位地区编码
    * yyyymmdd: 出生年(四位年)月日，如：19910215
    * xxx：顺序编码，系统产生，无法确定，奇数为男，偶数为女
    * y: 校验码，该位数值可通过前17位计算获得
    *
    * 前17位号码加权因子为 Wi = [ 7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2 ]
    * 验证位 Y = [ 1, 0, 10, 9, 8, 7, 6, 5, 4, 3, 2 ]
    * 如果验证码恰好是10，为了保证身份证是十八位，那么第十八位将用X来代替
    * 校验位计算公式：Y_P = mod( ∑(Ai×Wi),11 )
    * i为身份证号码1...17 位; Y_P为校验码Y所在校验码数组位置
    */

    static idCard(idCard) {
        let isPass = true;
        //15位和18位身份证号码的正则表达式
        let regIdCard = /^(^[1-9]\d{7}((0\d)|(1[0-2]))(([0|1|2]\d)|3[0-1])\d{3}$)|(^[1-9]\d{5}[1-9]\d{3}((0\d)|(1[0-2]))(([0|1|2]\d)|3[0-1])((\d{4})|\d{3}[Xx])$)$/;

        //如果通过该验证，说明身份证格式正确，但准确性还需计算
        if (regIdCard.test(idCard)) {
            if (idCard.length == 18) {
                let idCardWi = new Array(7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2); //将前17位加权因子保存在数组里
                let idCardY = new Array(1, 0, 10, 9, 8, 7, 6, 5, 4, 3, 2); //这是除以11后，可能产生的11位余数、验证码，也保存成数组
                let idCardWiSum = 0; //用来保存前17位各自乖以加权因子后的总和
                for (let i = 0; i < 17; i++) {
                    idCardWiSum += idCard.substring(i, i + 1) * idCardWi[i];
                }

                let idCardMod = idCardWiSum % 11;//计算出校验码所在数组的位置
                let idCardLast = idCard.substring(17);//得到最后一位身份证号码
                //如果等于2，则说明校验码是10，身份证号码最后一位应该是X
                if (idCardMod == 2) {
                    if (idCardLast == "X" || idCardLast == "x") {
                        isPass=  true;
                    } else {//你的身份证不正确
                        isPass=  false;
                    }
                } else {
                    //用计算出的验证码与最后一位身份证号码匹配，如果一致，说明通过，否则是无效的身份证号码
                    if (idCardLast == idCardY[idCardMod]) {
                        isPass=  true;
                    } else {//你的身份证不正确
                        isPass=  false;
                    }
                }
            }
        } else {//你的身份证不正确
            isPass=  false;
        }
        let returnObj = { isPass: '', message: '' }
        if (!isPass) {
            returnObj.isPass = 'false';
            returnObj.message = '请填写合法的身份证号'
        } else {
            returnObj.isPass = 'true';
        }
        return returnObj;
    }

    static mail(value) {
        let isPass = true;
        let reg = /^[A-Za-z0-9-\u4e00-\u9fa5]+@[a-zA-Z0-9_-]+(\.[a-zA-Z0-9_-]+)+$/;
        if (reg.test(value.trim()) == true) {
            isPass=  true;
        } else {
            isPass=  false;
        }
        let returnObj = { isPass: '', message: '' }
        if (!isPass) {
            returnObj.isPass = 'false';
            returnObj.message = '请填写有效的邮箱地址'
        } else {
            returnObj.isPass = 'true';
        }
        return returnObj;
    }


};
export { verify }



